'
' Created by SharpDevelop.
' User: Lee, Dong-Liang  http://dllee.ktop.com.tw
' Date: 2005/3/19
' Time: 09:50 PM
' 
' This is a test program for testing WMI objects in VB.NET in #Develop
'
Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Data
Imports System.Drawing
Imports System.Windows.Forms

Namespace testScript
	
	Public Class MainForm
		Inherits System.Windows.Forms.Form
		Private label1 As System.Windows.Forms.Label
		Private button1 As System.Windows.Forms.Button
		
		Public Shared Sub Main
			Dim fMainForm As New MainForm
			fMainForm.ShowDialog()
		End Sub
		
		Public Sub New()
			MyBase.New
			'
			' The Me.InitializeComponent call is required for Windows Forms designer support.
			'
			Me.InitializeComponent
			'
			' TODO : Add constructor code after InitializeComponents
			'
		End Sub
		
		#Region " Windows Forms Designer generated code "
		' This method is required for Windows Forms designer support.
		' Do not change the method contents inside the source code editor. The Forms designer might
		' not be able to load this method if it was changed manually.
		Private Sub InitializeComponent()
			Me.button1 = New System.Windows.Forms.Button
			Me.label1 = New System.Windows.Forms.Label
			Me.SuspendLayout
			'
			'button1
			'
			Me.button1.Location = New System.Drawing.Point(280, 152)
			Me.button1.Name = "button1"
			Me.button1.Size = New System.Drawing.Size(112, 48)
			Me.button1.TabIndex = 1
			Me.button1.Text = "Read Temperature"
			AddHandler Me.button1.Click, AddressOf Me.Button1Click
			'
			'label1
			'
			Me.label1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom)  _
						Or System.Windows.Forms.AnchorStyles.Left)  _
						Or System.Windows.Forms.AnchorStyles.Right),System.Windows.Forms.AnchorStyles)
			Me.label1.Location = New System.Drawing.Point(8, 8)
			Me.label1.Name = "label1"
			Me.label1.Size = New System.Drawing.Size(392, 480)
			Me.label1.TabIndex = 0
			Me.label1.Text = "label1"
			'
			'MainForm
			'
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 15)
			Me.ClientSize = New System.Drawing.Size(408, 494)
			Me.Controls.Add(Me.button1)
			Me.Controls.Add(Me.label1)
			Me.Name = "MainForm"
			Me.Text = "WMI VB.NET testing http://dllee.ktop.com.tw"
			AddHandler Load, AddressOf Me.MainFormLoad
			Me.ResumeLayout(false)
		End Sub
		#End Region
		
		Private Sub MainFormLoad(sender As System.Object, e As System.EventArgs)
		' ref: MicroSoft Script Center : Enumerating Processor Information
		' ref: http://www.microsoft.com/technet/scriptcenter/scripts/hardware/basic/hwbavb03.mspx
			Dim p_objSet As Object
			Dim objItem As Object 
			p_objSet =GetObject("winmgmts:" _
    			& "{impersonationLevel=impersonate}!\\.\root\cimv2"). _
			    ExecQuery("Select * from Win32_Processor")
			For Each objItem in p_objSet
				label1.Text = "Address Width: " & objItem.AddressWidth & vbCrLf & _
     				"Architecture: " & objItem.Architecture & vbCrLf & _
     				"Availability: " & objItem.Availability & vbCrLf & _
     				"CPU Status: " & objItem.CpuStatus & vbCrLf & _
     				"Current Clock Speed: " & objItem.CurrentClockSpeed & vbCrLf & _
     				"Data Width: " & objItem.DataWidth & vbCrLf & _
     				"Description: " & objItem.Description & vbCrLf & _
     				"Device ID: " & objItem.DeviceID & vbCrLf & _
     				"External Clock: " & objItem.ExtClock & vbCrLf & _
     				"Family: " & objItem.Family & vbCrLf & _
     				"L2 Cache Size: " & objItem.L2CacheSize & vbCrLf & _
     				"L2 Cache Speed: " & objItem.L2CacheSpeed & vbCrLf & _
     				"Level: " & objItem.Level & vbCrLf & _
     				"Load Percentage: " & objItem.LoadPercentage & vbCrLf & _
     				"Manufacturer: " & objItem.Manufacturer & vbCrLf & _
     				"Maximum Clock Speed: " & objItem.MaxClockSpeed & vbCrLf & _
     				"Name: " & objItem.Name & vbCrLf & _
     				"PNP Device ID: " & objItem.PNPDeviceID & vbCrLf & _
     				"Processor ID: " & objItem.ProcessorId & vbCrLf & _
     				"Processor Type: " & objItem.ProcessorType & vbCrLf & _
     				"Revision: " & objItem.Revision & vbCrLf & _
     				"Role: " & objItem.Role & vbCrLf & _
     				"Socket Designation: " & objItem.SocketDesignation & vbCrLf & _
     				"Status Information: " & objItem.StatusInfo & vbCrLf & _
     				"Stepping: " & objItem.Stepping & vbCrLf & _
     				"Unique Id: " & objItem.UniqueId & vbCrLf & _
     				"Upgrade Method: " & objItem.UpgradeMethod & vbCrLf & _
     				"Version: " & objItem.Version & vbCrLf & _
     				"Voltage Caps: " & objItem.VoltageCaps
			Next
		End Sub
		
		Private Sub Button1Click(sender As System.Object, e As System.EventArgs)
		' ref: Samurize - System Information - Scripts & Plugins
		' ref: ACPI_CPUTemp by Punkt
		' ref: http://www.samurize.com/modules/mydownloads/viewcat.php?cid=6
			Dim PFU As Object
			Dim U As Object 
						
			PFU =GetObject("winmgmts:" _
    			& "{impersonationLevel=impersonate}!\\.\root\wmi"). _
			    ExecQuery("Select * from MSAcpi_ThermalZoneTemperature")
   			For Each U in PFU
      			label1.Text = "CurrentTemperature(RawData): " & U.CurrentTemperature & vbCrLf & _
                    "Temperature(C):     " & ((U.CurrentTemperature - 2732) / 10)      
   			Next
  		End Sub
		
	End Class
End Namespace
